import { jsx as c, jsxs as p, Fragment as z } from "react/jsx-runtime";
import i from "clsx";
import N, { useState as U, useEffect as L } from "react";
/*!
  @versini/ui-bubble v1.4.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUBBLE__ || (window.__VERSINI_UI_BUBBLE__ = {
    version: "1.4.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const P = "av-bubble", T = "av-button";
/*!
  @versini/ui-spacing v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const $ = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, B = "icon", H = "button", j = "link", A = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a,
  align: o
}) => {
  const d = "text-sm font-medium max-h-8 py-0", s = "text-base font-medium max-h-9 py-1", l = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case H:
      return i("px-4", {
        [d]: r === "small",
        [s]: r === "medium",
        [l]: r === "large"
      });
    case j:
      return i("px-4 text-center", {
        [d]: r === "small",
        [s]: r === "medium",
        [l]: r === "large"
      });
    case B:
      return i("inline-flex items-center", {
        "justify-center": o === "center",
        "justify-start": o === "left",
        "justify-end": o === "right",
        "h-6 w-6 p-0": r === "small" && !(t || a),
        "h-6 px-4 text-sm font-medium": r === "small" && (t || a),
        "h-8 w-8 p-1": r === "medium" && !(t || a),
        "h-8 px-4 text-base font-medium": r === "medium" && (t || a),
        "h-12 w-12 p-2": r === "large" && !(t || a),
        "h-12 px-4 text-lg font-medium": r === "large" && (t || a)
      });
  }
}, G = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: a,
  radius: o
}) => {
  if (r)
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small"
    });
  if (a === "primary")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !t,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !t,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !t,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "selected")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !t,
      "bg-action-selected-dark text-copy-light": e === "dark",
      "bg-action-selected-light text-copy-lighter": e === "light",
      "bg-action-selected-dark text-copy-light dark:bg-action-selected-light dark:text-copy-lighter": e === "system",
      "bg-action-selected-light text-copy-lighter dark:bg-action-selected-dark dark:text-copy-light": e === "alt-system"
    });
}, O = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
  if (t === "selected")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-selected-dark-hover": e === "dark",
      "hover:bg-action-selected-light-hover": e === "light",
      "hover:bg-action-selected-dark-hover dark:hover:bg-action-selected-light-hover": e === "system",
      "hover:bg-action-selected-light-hover dark:hover:bg-action-selected-dark-hover": e === "alt-system"
    });
}, W = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
  if (t === "selected")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-selected-dark-active": e === "dark",
      "active:bg-action-selected-light-active": e === "light",
      "active:bg-action-selected-dark-active dark:active:bg-action-selected-light-active": e === "system",
      "active:bg-action-selected-light-active dark:active:bg-action-selected-dark-active": e === "alt-system"
    });
}, q = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
  if (t === "selected")
    return i("border", {
      "border-border-selected-dark": e === "dark",
      "border-border-selected-medium": e === "light",
      "border-border-selected-dark dark:border-border-selected-medium": e === "system",
      "border-border-selected-medium dark:border-border-selected-dark": e === "alt-system"
    });
}, D = ({
  focusMode: e
}) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), C = ({
  type: e,
  className: r,
  raw: t,
  mode: a,
  focusMode: o,
  disabled: d,
  fullWidth: s,
  size: l,
  noBorder: b,
  labelRight: g,
  labelLeft: v,
  spacing: m,
  noBackground: u,
  variant: n,
  noTruncate: h,
  align: f,
  radius: y
}) => (n || (n = "primary"), t ? i(T, r) : i(
  T,
  r,
  $(m),
  G({
    mode: a,
    variant: n,
    noBackground: u,
    noTruncate: h,
    radius: y
  }),
  A({ type: e, size: l, labelRight: g, labelLeft: v, align: f }),
  q({ mode: a, variant: n, noBorder: b }),
  D({ focusMode: o }),
  O({ mode: a, variant: n, disabled: d }),
  W({ mode: a, variant: n, disabled: d }),
  {
    "w-full": s,
    "disabled:cursor-not-allowed disabled:opacity-50": d
  }
)), F = (e, r, t) => {
  var a;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, S = N.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: a = !1, ...o } = e;
  return /* @__PURE__ */ c(
    "button",
    {
      ref: r,
      onClick: (d) => {
        F(d, a, t);
      },
      ...o
    }
  );
});
S.displayName = "BaseButton";
const E = N.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: o = !1,
    className: d,
    type: s = "button",
    raw: l = !1,
    noBorder: b = !1,
    "aria-label": g,
    label: v,
    size: m = "medium",
    labelRight: u,
    labelLeft: n,
    spacing: h,
    noBackground: f = !1,
    align: y = "center",
    radius: k = "large",
    ...x
  }, _) => {
    const w = C({
      type: B,
      mode: t,
      focusMode: a,
      fullWidth: o,
      disabled: r,
      raw: l,
      className: d,
      noBorder: b,
      size: m,
      labelRight: u,
      labelLeft: n,
      spacing: h,
      noBackground: f,
      align: y,
      radius: k
    }), I = i({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    });
    return /* @__PURE__ */ p(
      S,
      {
        ref: _,
        className: w,
        disabled: r,
        type: s,
        "aria-label": g || v,
        ...x,
        children: [
          n && /* @__PURE__ */ c("span", { className: "pr-2", children: n }),
          /* @__PURE__ */ c("div", { className: I, children: e }),
          u && /* @__PURE__ */ c("span", { className: "pl-2", children: u })
        ]
      }
    );
  }
);
E.displayName = "ButtonIcon";
/*!
  @versini/ui-button v1.7.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "1.7.0",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const J = N.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: o = !1,
    className: d,
    type: s = "button",
    raw: l = !1,
    noBorder: b = !1,
    "aria-label": g,
    label: v,
    size: m = "medium",
    labelRight: u,
    labelLeft: n,
    spacing: h,
    noBackground: f = !1,
    align: y = "center",
    active: k = !1,
    radius: x = "large",
    ..._
  }, w) => {
    const I = C({
      type: B,
      mode: t,
      focusMode: a,
      fullWidth: o,
      disabled: r,
      raw: l,
      className: d,
      noBorder: b,
      size: m,
      labelRight: u,
      labelLeft: n,
      spacing: h,
      noBackground: f,
      align: y,
      radius: x
    }), V = i({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    }), R = k ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ c("div", { className: R, children: /* @__PURE__ */ p(
      S,
      {
        ref: w,
        className: I,
        disabled: r,
        type: s,
        "aria-label": g || v,
        ..._,
        children: [
          n && /* @__PURE__ */ c("span", { className: "pr-2", children: n }),
          /* @__PURE__ */ c("div", { className: V, children: e }),
          u && /* @__PURE__ */ c("span", { className: "pl-2", children: u })
        ]
      }
    ) });
  }
);
J.displayName = "ButtonSort";
/*!
  @versini/ui-spacing v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const K = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, M = ({
  children: e,
  fill: r,
  viewBox: t,
  className: a,
  defaultViewBox: o,
  defaultClassName: d,
  spacing: s,
  title: l,
  semantic: b = !1,
  ...g
}) => {
  const v = K(s), m = i(
    v,
    a || d
  );
  return /* @__PURE__ */ p(z, { children: [
    /* @__PURE__ */ c(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: m,
        viewBox: t || o,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !b,
        focusable: !1,
        ...g,
        children: e
      }
    ),
    l && b && /* @__PURE__ */ c("span", { className: "sr-only", children: l })
  ] });
};
/*!
  @versini/ui-svgicon v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Q = ({
  className: e,
  viewBox: r,
  spacing: t,
  title: a,
  monotone: o,
  ...d
}) => /* @__PURE__ */ p(
  M,
  {
    defaultViewBox: "0 0 448 512",
    defaultClassName: "size-5",
    viewBox: r,
    className: e,
    spacing: t,
    title: a || "Copied",
    ...d,
    children: [
      /* @__PURE__ */ c(
        "path",
        {
          opacity: "0.4",
          d: "M64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H384c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64zM337 209L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0s9.4 24.6 0 33.9z"
        }
      ),
      /* @__PURE__ */ c("path", { d: "M337 175c9.4 9.4 9.4 24.6 0 33.9L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0z" })
    ]
  }
), X = ({
  className: e,
  viewBox: r,
  spacing: t,
  title: a,
  monotone: o,
  ...d
}) => /* @__PURE__ */ c(
  M,
  {
    defaultViewBox: "0 0 512 512",
    defaultClassName: "size-5",
    viewBox: r,
    className: e,
    spacing: t,
    title: a || "Copy",
    ...d,
    children: /* @__PURE__ */ c("path", { d: "M64 464H288c8.8 0 16-7.2 16-16V384h48v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V224c0-35.3 28.7-64 64-64h64v48H64c-8.8 0-16 7.2-16 16V448c0 8.8 7.2 16 16 16zM224 304H448c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H224c-8.8 0-16 7.2-16 16V288c0 8.8 7.2 16 16 16zm-64-16V64c0-35.3 28.7-64 64-64H448c35.3 0 64 28.7 64 64V288c0 35.3-28.7 64-64 64H224c-35.3 0-64-28.7-64-64z" })
  }
);
/*!
  @versini/ui-icons v1.19.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "1.19.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
/*!
  @versini/ui-spacing v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Y = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, Z = () => "p-4 sm:max-w-md md:max-w-2xl", ee = ({ kind: e }) => i({
  "bg-surface-lighter dark:bg-surface-dark": e === "left",
  "bg-surface-accent": e === "right"
}), te = ({ kind: e }) => i(
  "prose prose-dark dark:prose-lighter prose-p:my-3 prose-blockquote:my-3 prose-ol:my-3 prose-ul:my-3 prose-ul:prose-li:marker:text-black",
  {
    "text-copy-lighter": e === "right"
  }
), re = ({ kind: e }) => i("rounded-b-xl", {
  "rounded-tr-xl": e === "left",
  "rounded-tl-xl": e === "right"
}), ae = ({
  kind: e,
  className: r,
  spacing: t
}) => {
  const a = i(
    r,
    P,
    "flex items-start",
    Y(t),
    {
      "flex-row-reverse": e === "right"
    }
  ), o = i(
    "flex flex-col empty:hidden",
    Z(),
    te({ kind: e }),
    ee({ kind: e }),
    re({ kind: e })
  ), d = "pr-2 pt-1 text-end text-xs text-copy-light", s = i("flex flex-col-reverse gap-2 sm:flex-row", {
    "ml-2": e === "left",
    "mr-2": e === "right"
  });
  return {
    wrapper: a,
    main: o,
    footer: d,
    copyButton: s
  };
}, le = ({
  children: e,
  kind: r = "left",
  className: t,
  footer: a,
  rawFooter: o,
  copyToClipboard: d,
  copyToClipboardFocusMode: s = "system",
  copyToClipboardMode: l = "system",
  spacing: b
}) => {
  const [g, v] = U(!1), m = ae({ kind: r, className: t, spacing: b }), u = !!d && (typeof d == "function" || typeof d == "string" || typeof e == "string"), n = () => {
    v(!0), typeof d == "function" ? d(e) : typeof d == "string" ? navigator.clipboard.writeText(d) : typeof e == "string" && navigator.clipboard.writeText(e);
  };
  return L(() => {
    let h;
    return g && (h = window.setTimeout(() => {
      v(!1);
    }, 3e3)), () => {
      clearTimeout(h);
    };
  }, [g]), /* @__PURE__ */ p("div", { className: m.wrapper, children: [
    /* @__PURE__ */ p("div", { children: [
      /* @__PURE__ */ c("div", { className: m.main, children: e }),
      a && Object.keys(a).map((h) => a[h] ? /* @__PURE__ */ c("div", { className: "prose-p:m-0", children: /* @__PURE__ */ p("p", { className: m.footer, children: [
        h,
        ": ",
        a[h]
      ] }) }, `-${h}`) : null),
      o && o
    ] }),
    u && /* @__PURE__ */ c("div", { className: m.copyButton, children: /* @__PURE__ */ c(
      E,
      {
        noBorder: !0,
        noBackground: !0,
        size: "small",
        mode: l,
        focusMode: s,
        label: g ? "Copied to clipboard" : "Copy to clipboard",
        onClick: n,
        disabled: g,
        children: g ? /* @__PURE__ */ c(Q, { className: "size-3" }) : /* @__PURE__ */ c(X, { className: "size-3" })
      }
    ) })
  ] });
};
export {
  P as BUBBLE_CLASSNAME,
  le as Bubble
};
